package org.openxma.addons.ui.table.customizer.xma.client;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;

import at.spardat.xma.page.PageClient;

/**
 *
 */
public class FilterEmDate extends FilterEmDateGen {

    /**
     * Constructs the FilterEmDateGen.
     * @param parent the page where this page is embedded.
     */
    public FilterEmDate(PageClient parent) {
        super(parent);
    }

    /**
     * This method will be called every time the FilterEmDate becomes visible.
     */
    protected void enter() {
        super.enter();
        //TODO implement enter here!
    }

    /**
     * Recalculates the state variables of this page.
     * This method is called every time the content of any WizardModel of the
     * Page may have been changed. <br>
     * This method is called immediately before {@link #stateChanged()}.
     */
    public void determineState() {
        super.determineState();
    }

    /**
     * Enables or disables Widgets according to the current state of the page.
     * This method is called every time the content of any WizardModel of the
     * Page may have been changed. <br>
     * This method is called immediately after {@link #determineState()}.
     */
    public void stateChanged() {
        //If XMA-DSL is used with expression, some enabling/disabling is done in super
        super.stateChanged();
        boolean valid = valueFilter.getEncodedValue().trim().length()>0;
        valid = valid && operatorCombo.getSelected()!=null;
        addButtonW.setEnabled(valid);

        int indexOf = ((FilterPage)getParent()).elements.indexOf(this);
        if (indexOf > 0) { // not the first element
            valueFilter.setEnabled(linkOperandCombo.getSelected()!=null && operatorCombo.getSelected()!=null);
        }
    }

    @Override
    protected void createWidgets() {
        super.createWidgets();
        ((FilterPage)getParent()).applyUIPref(widgets);
    }

    /**
     * This method will be called every time the user clicks on addButtonW.
     */
    protected void addButtonWEvent() {
        ((FilterPage)getParent()).addFilter();
    }

    /**
     * This method will be called every time the user clicks on removeButtonW.
     */
    protected void removeButtonWEvent() {
        ((FilterPage)getParent()).removeFilter(this);
    }

    @Override
    protected void clientEvent(SelectionEvent event, int type) {
        super.clientEvent(event, type);
        if (event.widget == linkOperandComboW && SWT.Selection == type) {
            if (linkOperandCombo.getSelected()!=null) {
                ((FilterPage)getParent()).adjustFilterLinkOperators(linkOperandCombo.getSelected(), this);
            }
        }
    }


}
